REM '****************************************************
REM '      Light_Control.BAS
REM '    VER 5.3
REM '****************************************************
REM '      BASIC 
REM '****************************************************
REM '       .
REM '****************************************************
0000
[RESET]
CLR:NOERR 1:GOTO [START]
REM '   
0001
CLR:LINIT 1:LPRINT "RESTART":PAUSE 1000:NOERR 1
REM ' IF DEBUG need STOP, ELSE - rem
STOP
GOTO [START]
REM '****************************************************
REM '   
REM '****************************************************
#include DEFINE.BAS
#include MENU.BAS
#include TIMER.BAS
#include DATCHIK.BAS
REM '****************************************************
REM '              Start  system
REM '****************************************************
[START]
LINIT 1:BEEP 15,2:UART 1,5
LPRINT "Light Control":AT 64:LPRINT "V5.3 Start"
PAUSE 5500
REM '****************************************************
REM ' LOAD data
GOSUB [LoadData]
GOSUB [TestValidData]
REM '****************************************************

=1:GOSUB [WORK_Timer_0]
IF =0 THEN RT_Count_5=32760:LIGHT_OFF
CLS:LPRINT "Device start"
PAUSE 500

REM '****************************************************
REM                       MAIN
REM '****************************************************
[MAIN]
GOSUB [R_Timer]

REM '        
IF RT_Count_4=<Time_WT_Light THEN GOTO [SKIPP_LIGHT_ON]
REM ' /   
=1
GOSUB [WORK_Timer_0]
IF =1 THEN LIGHT_ON
IF =0 THEN LIGHT_OFF
[SKIPP_LIGHT_ON]

REM '   
GOSUB [WORK_Timer_1]

REM '  CO
GOSUB [WORK_Timer_2]




GOSUB [DISPLAY]

GOSUB [MENU]
GOTO [MAIN]
REM '****************************************************
REM '****************************************************


REM '****************************************************
REM              
REM '****************************************************

REM '****************************************************
[DISPLAY]
AT 0:LPRINT "    "
SDATE $(TXT_Buffer):LPRINT *$(TXT_Buffer),"        "
AT 64:LPRINT " "
STIME $(TXT_Buffer):LPRINT *$(TXT_Buffer)
LPRINT "  "
=LIGHT_IN:LCDD 238
IF =1 THEN LPRINT "-ON  "
IF =0 THEN LPRINT "-OFF "

RETURN

REM '****************************************************
REM '      
REM '    OK  ,    
REM '   
REM '****************************************************
[MENU]
REM '     ?
=GKEY{}:IF =0 THEN RETURN
REM '   
BEEP 15,2:CLS:LPRINT "   -OK "
PAUSE 100:=KEY{2}:BEEP 15,2:IF =_ok THEN GOTO [MENU_START]
=GKEY{}:IF <>0 THEN GOTO +0
RETURN

[MENU_START]
REM '    
BEEP 15,2:GOSUB [INIT_DEVICE]
REM '   
GOSUB [Global_MENU]
REM ' LOAD UPDATE data
GOSUB [LoadData]
RETURN
REM '****************************************************

[INIT_DEVICE]
REM '   ,    
REM '     
LIGHT_OFF:CLS
RETURN

REM '****************************************************
[LoadData]
Var_Hour_ON=RDEE{EE_Time_ON}
=EE_Time_ON+2
Var_Min_ON=RDEE{}

Var_Hour_OFF=RDEE{EE_Time_OFF}
=EE_Time_OFF+2
Var_Min_OFF=RDEE{}
RETURN

REM '****************************************************
[SaveData]
WREE Var_Hour_ON,EE_Time_ON
=EE_Time_ON+2
WREE Var_Min_ON,

WREE Var_Hour_OFF,EE_Time_OFF
=EE_Time_OFF+2
WREE Var_Min_OFF,
RETURN

REM '****************************************************
REM '      1  
REM '****************************************************
[TestValidData]
IF Var_Hour_ON>23 THEN GOTO [SetDefault]
IF Var_Hour_ON<0 THEN GOTO [SetDefault]

IF Var_Hour_OFF>23 THEN GOTO [SetDefault]
IF Var_Hour_OFF<0 THEN GOTO [SetDefault]

IF Var_Min_ON>59 THEN GOTO [SetDefault]
IF Var_Min_ON<0 THEN GOTO [SetDefault]

IF Var_Min_OFF>59 THEN GOTO [SetDefault]
IF Var_Min_OFF<0 THEN GOTO [SetDefault]
RETURN

REM '****************************************************
[SetDefault]
Var_Hour_ON=14:Var_Hour_OFF=15
Var_Min_ON=0:Var_Min_OFF=0
GOSUB [SaveData]
RETURN


REM '****************************************************
REM '****************************************************



